
var parenthesis=new Array();
var parenthesisNestLocator=new Array();
var equationNumbers=new Array();
var currentNumberIndex=0;
var errorMessage=false;
var variableNames=new Array();
var variables=new Array();
var variableIndex=0;
setVariable('pi', Math.PI);
var functionArray=new Array('', 'exp', 'sin', 'cos', 'tan', 'sqrt', 'sinh', 'cosh', 'ln', 'log', 'tanh', 'csc', 'sec', 'cot', 'csch', 'sech', 'coth', 'asin', 'acos', 'atan', 'bin');
function calculateEquation(equationToCalculate)
{
var answer={errorMessage:false, answer:'', variableStoredIn:false};
var tokenizedEquation;
var equalsLocation, variableToStoreAnswerIn=false;
resetCalculationVariables();
if (equationToCalculate=='') {
answer.errorMessage='Nothing to calculate.';
return answer;
}
if (commaLocale) { 
equationToCalculate=equationToCalculate.replace(/,/g, '.');
}
if (equationToCalculate.match(RegExp('\\(\\)'))) { 
answer.errorMessage='Need arguments in parenthesis';
return answer;
}
equalsLocation=equationToCalculate.indexOf('=');
if (equalsLocation!=-1) { 
if (equalsLocation!=equationToCalculate.lastIndexOf('=')) {
answer.errorMessage='More than one equals sign.';
return answer;
}
variableToStoreAnswerIn=equationToCalculate.substring(0, equalsLocation);
equationToCalculate=equationToCalculate.substring(equalsLocation+1);
if (!isValidVariable(variableToStoreAnswerIn)) {
if (errorMessage) {
answer.errorMessage=errorMessage;
} else {
answer.errorMessage=variableToStoreAnswerIn + " is not a valid variable name.";
}
return answer;
}
}
equationToCalculate=equationToCalculate.replace(/%/g, '/(100)');

tokenizedEquation=tokenizeNumbers(equationToCalculate);
if (errorMessage) {
answer.errorMessage=errorMessage;
return answer;
}
tokenizedEquation=tokenizeParens(tokenizedEquation);
if (errorMessage) {
answer.errorMessage=errorMessage;
return answer;
}
tokenizedEquation=calculateTokenizedEquation(tokenizedEquation);
if (errorMessage) {
} else if (isNaN(tokenizedEquation)) {
errorMessage='NaN (or possibly an imaginary number).';
} else if (tokenizedEquation===false) {
errorMessage='NaN (or possibly very large).';
} else if (tokenizedEquation=="Infinity") {
errorMessage='Number is greater than ~10^308.';
}	
if (errorMessage) {
answer.errorMessage=errorMessage;
return answer;
}
if (variableToStoreAnswerIn) {
setVariable(variableToStoreAnswerIn, 	tokenizedEquation);
answer.variableStoredIn=variableToStoreAnswerIn;
}
answer.errorMessage=errorMessage;
answer.answer=tokenizedEquation;
resetCalculationVariables()
return answer;
}
function resetCalculationVariables()
{
parenthesis=new Array();
parenthesisNestLocator=new Array();
equationNumbers=new Array();
currentNumberIndex=0;
errorMessage=false;
}
function tokenizeNumbers(equationToTokenize) 
{
var i, keycode, tempkeycode, tokenizedEquation='', currentNumber='', parenthesisNestCount=0, functionNumber=0, addParenthesis=0, parseNegativeNumber='', previousKeycode=-1;
var currentNumberToAdd;
var decimalCount=0, negativeCount=0, currentOperator='';
var exponentCount=0;
var answerNumber='';
var currentStackIndex;
var currentString, currentVariableIndex;
for (i=0; i<=equationToTokenize.length-1; i++) {
keycode=equationToTokenize.charCodeAt(i);
if ((keycode>=48 && keycode<=57) || keycode==46) { 
i+=parsePDNumber(parseNegativeNumber+''+equationToTokenize.substring(i));
if (parseNegativeNumber=='-')
i--;
if (errorMessage)
return "";
tokenizedEquation=tokenizedEquation + '['+(currentNumberIndex-1)+']';
parseNegativeNumber='';
keycode=equationToTokenize.charCodeAt(i+1);
if (keycode!=41 && keycode!=42 && keycode!=43 && keycode!=45 && keycode!=47 && keycode!=94 && !isNaN(keycode)) {
if (getStringUpToOperator(equationToTokenize.substring(i+1)))
errorMessage='error near ' + equationNumbers[currentNumberIndex-1].getMasterNumber() + getStringUpToOperator(equationToTokenize.substring(i+1));
else 
errorMessage='error near ' + equationNumbers[currentNumberIndex-1].getMasterNumber() + equationToTokenize.charAt(i+1);
return "";
} 
} else if (keycode==40 || keycode==41 || keycode==42 || keycode==43 || keycode==45 || keycode==47 || keycode==94) { 
currentOperator=equationToTokenize.charAt(i);
if (keycode==43 || keycode==45) {
while (equationToTokenize.charCodeAt(i)==43 || equationToTokenize.charCodeAt(i)==45) {
if (equationToTokenize.charCodeAt(i)==45) {
negativeCount++;
}
i++;
}
i--; 
if ((negativeCount%2)) { 
currentOperator='-';
keycode=45;
} else {
currentOperator='+';
keycode=43;
}
negativeCount=0;
}
if ((i+1)==equationToTokenize.length && keycode!=41) {
errorMessage=equationToTokenize.charAt(i) +' at end of formula.';
return "";
}
if (keycode==45) { 
if (previousKeycode==94) {
parseNegativeNumber='-';	
} else if (previousKeycode==-1 || previousKeycode==40 || previousKeycode==42) {
parseNegativeNumber='';
currentStackIndex=addNumberToStack(-1);
tokenizedEquation=tokenizedEquation+'['+currentStackIndex+']*';
} else if (previousKeycode==47) { 
parseNegativeNumber='';
currentStackIndex=addNumberToStack(-1);
tokenizedEquation=tokenizedEquation+'['+currentStackIndex+']/';
} else {
parseNegativeNumber='';
tokenizedEquation=tokenizedEquation+''+currentOperator;
}
} else if (keycode==43) {
if (previousKeycode==94 || previousKeycode==-1 || previousKeycode==40 || previousKeycode==42 || previousKeycode==47) { 
} else {
tokenizedEquation=tokenizedEquation+''+currentOperator;
}
} else if (keycode==40 || keycode==42 || keycode==47 || keycode==94) { 
if (equationToTokenize.charCodeAt(i+1)==42 || equationToTokenize.charCodeAt(i+1)==47 || equationToTokenize.charCodeAt(i+1)==94) { 
errorMessage='error near ' + equationToTokenize.charAt(i) + equationToTokenize.charAt(i+1);
return "";
} else {
tokenizedEquation=tokenizedEquation+''+currentOperator;
}
} else if (keycode==41) { 
if (equationToTokenize.charCodeAt(i+1)==41 || equationToTokenize.charCodeAt(i+1)==42 || equationToTokenize.charCodeAt(i+1)==43 || equationToTokenize.charCodeAt(i+1)==45 || equationToTokenize.charCodeAt(i+1)==47 || equationToTokenize.charCodeAt(i+1)==94 || isNaN(equationToTokenize.charCodeAt(i+1))) { 
tokenizedEquation=tokenizedEquation+''+currentOperator;
} else {
errorMessage='error near ' + equationToTokenize.charAt(i) + equationToTokenize.charAt(i+1);
return "";
}
} else {
tokenizedEquation=tokenizedEquation+''+currentOperator;
}
if (keycode==40)
parenthesisNestCount++;
else if (keycode==41)
parenthesisNestCount--;
} else { 
currentString=getStringUpToOperator(equationToTokenize.substring(i));
functionNumber=parseFunction(currentString);
if (functionNumber) { 
i+=(functionArray[functionNumber].length-1);
tempkeycode=equationToTokenize.charCodeAt(i+1);
if (tempkeycode==42 || tempkeycode==43 || tempkeycode==47 || tempkeycode==94 || isNaN(tempkeycode)) { 
errorMessage='Illegal character after '+ functionArray[functionNumber]+ '.';
return "";
}				
tokenizedEquation=tokenizedEquation+'f'+parseNegativeNumber+functionNumber;
parseNegativeNumber='';
} else { 
currentVariableIndex=getVariableIndex(currentString);
if (currentVariableIndex!=-1) { 
currentStackIndex=addVariableToStack(currentVariableIndex);
tokenizedEquation=tokenizedEquation + '['+currentStackIndex+']';
i+=(currentString.length-1);
if (equationToTokenize.charAt(i+1)=='(') { 
errorMessage="error near "+currentString+"(";
return "";
}
} else { 
errorMessage=currentString + " is not a variable.";
return "";
}
}
}
previousKeycode=keycode;
}
return tokenizedEquation;
}
function addNumberToStack (numberToAdd)
{	
equationNumbers[currentNumberIndex]=new PDNumber(numberToAdd);
return currentNumberIndex++;
}
function addVariableToStack(currentVariableIndex)
{	
equationNumbers[currentNumberIndex]=variables[currentVariableIndex];
return currentNumberIndex++;
}
function setVariable(currentVariableName, currentVariableValue)
{	
var currentVariableIndex=getVariableIndex(currentVariableName);
if (currentVariableIndex!=-1) { 
variables[currentVariableIndex]=new PDNumber(currentVariableValue);
} else { 
variables[variableIndex]=new PDNumber(currentVariableValue);
variableNames[variableIndex]=currentVariableName;
variableIndex++;
}
}
function calculateTokenizedEquation(tokenizedEquation)
{
var answer, parethesisToReplace;
var i, j, okToCalculate, tempVariable='';
for (i=parenthesis.length-1; i>=0; i--) {
okToCalculate=1;
for (j=0; j<=parenthesis[i].length-1; j++) {
if (parenthesis[i].charAt(j)=='[') {	
j++;
if (parenthesis[i].charAt(j)=='p') { 
j++;
tempVariable=parenthesis[i].substring(j);
tempVariable=parseInt(tempVariable);
if (!isNaN(tempVariable)) { 
if (parenthesis[tempVariable].charAt(0)=='[') okToCalculate=0;
} else {
errorMessage="Internal Error. Please send in a bug report.";
break;
}				
}				
}
} 
if (okToCalculate!='0') {
parenthesis[i]=calculateFunctions(parenthesis[i]);
if (parenthesis[i]=='error') {
errorMessage="Internal error, please submit bug report;";
return "";
}
parenthesis[i]=mDAS(parenthesis[i]); 
parenthesis[i]=addNumberToStack(parenthesis[i]);
if (i!='0') {
parethesisToReplace=new RegExp('\\[p'+i+'\\]');
parenthesis[parenthesisNestLocator[i]]=parenthesis[parenthesisNestLocator[i]].replace(parethesisToReplace, '['+parenthesis[i]+']');
}
}
}
parenthesis[0]=equationNumbers[parenthesis[0]].getNumber();
answer=parenthesis[0];
return answer;
}
function calculateFunctions(stringToCalculate)
{
var i, functionNumber, num1, num2, replaceRegEx, tempans, recalculate=0, finalAnswerIsNegative='', loopCount=0;
var currentStackIndex, currentNumber;
while (stringToCalculate.indexOf('f')!=-1) {
loopCount++;
if (loopCount>1000) {
errorMessage='Internal Error.  Please report.'
return false;
}
i=stringToCalculate.indexOf('f');
finalAnswerIsNegative=''; 
functionNumber=parseInt(stringToCalculate.substring(i+1));
functionNumber=functionNumber.toString();
i+=(functionNumber.length+1); 
num1=parseInt(stringToCalculate.substring(i+1));
currentNumber=num1;
replaceRegEx=new RegExp('f'+functionNumber + '\\['+num1+'\\]');
num1=equationNumbers[num1].getNumber();
functionNumber=parseInt(functionNumber);
if (functionNumber<0) {
functionNumber=-functionNumber;
finalAnswerIsNegative='-';
}
if (!preferencesRadians) {
if (functionNumber==2 || functionNumber==3 || functionNumber==4 || functionNumber==6 || functionNumber==7 || (functionNumber>=10 && functionNumber<=16)) {
num1=num1*Math.PI/180;
}
}
switch(functionNumber) {
case 1:
tempans=Math.exp(num1);
break;
case 2:
tempans=Math.sin(num1);
tempans=formatTrigFunction(tempans);
break;
case 3:
tempans=Math.cos(num1);
tempans=formatTrigFunction(tempans);
break;
case 4:
tempans=Math.tan(num1);
break;
case 5:
tempans=Math.sqrt(num1);
break;
case 6: 
tempans=(Math.exp(num1)-Math.exp(-num1))/2;
break;
case 7: 
tempans=(Math.exp(num1)+Math.exp(-num1))/2;
break;
case 8: 
tempans=Math.log(num1);
break;
case 9: 
tempans=Math.log(num1)/Math.LN10;
break;
case 10: 
tempans=(Math.exp(num1)-Math.exp(-num1))/(Math.exp(num1)+Math.exp(-num1));
break;
case 11: 
tempans=Math.sin(num1);
tempans=formatTrigFunction(tempans);
tempans=1/tempans;
break;
case 12: 
tempans=Math.cos(num1);
tempans=formatTrigFunction(tempans);
tempans=1/tempans;
break;
case 13: 
tempans=1/Math.tan(num1);
break;
case 14: 
tempans=2/(Math.exp(num1)-Math.exp(-num1));
break;
case 15: 
tempans=2/(Math.exp(num1)+Math.exp(-num1));
break;
case 16: 
tempans=(Math.exp(num1)+Math.exp(-num1))/(Math.exp(num1)-Math.exp(-num1));
break;
case 17:
tempans=Math.asin(num1);
break;
case 18:
tempans=Math.acos(num1);
break;
case 19:
tempans=Math.atan(num1);
break;
case 20:
num1=equationNumbers[currentNumber].getMasterNumber();
tempans=parseInt(num1, 2);
if (isNaN(tempans)) {
errorMessage=equationNumbers[currentNumber].getMasterNumber()+ " is not a valid binary number";
}
break;
case 21:
tempans=parseInt(num1, 8);
break;
case 22:
tempans=parseInt(num1, 16);
break;
}
if (!preferencesRadians) { 
if (functionNumber>=17 && functionNumber<=19) {
tempans=tempans*180/Math.PI;
}
}
currentStackIndex=addNumberToStack(finalAnswerIsNegative+''+tempans);
stringToCalculate=stringToCalculate.replace(replaceRegEx, '['+currentStackIndex+']');
}
loopCount=0;
while (stringToCalculate.indexOf('^')!=-1)
{
loopCount++;
if (loopCount>1000) {
errorMessage='Internal Error.  Please report.'
return false;
}
i=stringToCalculate.lastIndexOf('^');
num1=parseInt(stringToCalculate.substring((stringToCalculate.substring(0, i)).lastIndexOf('[')+1));
num2=parseInt(stringToCalculate.substring(i+2));
replaceRegEx=new RegExp('\\['+num1+ '\\]\\^\\['+ num2+'\\]'); 
num1=equationNumbers[num1].getNumber();
num2=equationNumbers[num2].getNumber();
tempans=Math.pow(num1,num2);
currentStackIndex=addNumberToStack(tempans);
stringToCalculate=stringToCalculate.replace(replaceRegEx, '['+currentStackIndex+']');
}
if (loopCount>=1000) {
errorMessage= "Internal error.  Please report.";
return "";
}
return stringToCalculate;
}
function parsePDNumber(stringToParse)
{
var i=0;
var currentNumber=stringToParse.charAt(i);
var nextCharCode=stringToParse.charCodeAt(i+1);
var currentNumberToAdd='';
var decimalCount=0, exponentCount=0;
var masterNumber;
var typeOfNumber=0, masterNumberLength;
if (preferencesProgrammerMode) { 
masterNumber=getStringUpToOperator(stringToParse);
if (masterNumber.charAt(0)=='0') {
if (masterNumber.charAt(1)=='x') { 
currentNumberToAdd=parseInt(masterNumber,16);
if (masterNumber.indexOf('.')!=-1)
errorMessage=masterNumber+" can't have decimals.";
else if (isNaN(currentNumberToAdd))
errorMessage=masterNumber+" is not a valid hex number.";
addNumberToStack(currentNumberToAdd);
return (masterNumber.length-1); 
} else if (masterNumber.charAt(1)!='.') { 
currentNumberToAdd=parseInt(masterNumber,8);
if (masterNumber.indexOf('.')!=-1)
errorMessage=masterNumber+" can't have decimals.";
else if (isNaN(currentNumberToAdd))
errorMessage=masterNumber+" is not a valid octal number.";
masterNumberLength=masterNumber.length
while (i<masterNumberLength) {
if (masterNumber.charCodeAt(i++)>55) { 
errorMessage=masterNumber+" is not a valid octal number.";
return 1;
}
}
addNumberToStack(currentNumberToAdd);
(equationNumbers[currentNumberIndex-1]).setMasterNumber(masterNumber);
return (masterNumber.length-1); 
} 
}
}
while ((nextCharCode>=48 && nextCharCode<=57) || nextCharCode==46 || nextCharCode==101) {
i++;
currentNumberToAdd=stringToParse.charAt(i);
if (currentNumberToAdd=='.') {  
decimalCount++;
if (exponentCount) {	
errorMessage='Exponent must be integer.'; 
return 0;
}
} else if (currentNumberToAdd=='e') { 
exponentCount++;
if (stringToParse.charCodeAt(i+1)==45) {
currentNumberToAdd='e-';
i++;
} else if (stringToParse.charCodeAt(i+1)>=48 && stringToParse.charCodeAt(i+1)<=57) {
} else {
errorMessage='Need integer in exponent.';
return 0;
}
}
currentNumber=currentNumber+''+currentNumberToAdd;
nextCharCode=stringToParse.charCodeAt(i+1);
} 
if (decimalCount>1) {
errorMessage='Too many decimals.';
return 0;
}
if (exponentCount>1) {
errorMessage='Too many exponents.';
return 0;
}
addNumberToStack(currentNumber);
return i;
}
function tokenizeParens(equationToTokenize)
{ 
var i, currentChar='', tokenizedEquation='', currentParenthesisNumber=0, parenthesisDepth=0;
var currentParethesisTracker=new Array(); 
parenthesis[0]='';
currentParethesisTracker[0]=0;
parenthesisNestLocator[0]=-1;
for (i=0; i<=equationToTokenize.length-1; i++)
{
currentChar=equationToTokenize.charAt(i);
if (currentChar=='(') 
{
currentParenthesisNumber++;
parenthesis[currentParenthesisNumber]='';
parenthesisDepth++;
currentParethesisTracker[parenthesisDepth]=currentParenthesisNumber;
}
else if (currentChar==')') 
{	
parenthesisNestLocator[currentParethesisTracker[parenthesisDepth]]=currentParethesisTracker[parenthesisDepth-1]; 
parenthesisDepth--;
parenthesis[currentParethesisTracker[parenthesisDepth]]=parenthesis[currentParethesisTracker[parenthesisDepth]]+'[p'+currentParethesisTracker[parenthesisDepth+1]+']';
}
else 
{
parenthesis[currentParethesisTracker[parenthesisDepth]]=parenthesis[currentParethesisTracker[parenthesisDepth]]+''+currentChar;
}
}
if (parenthesisDepth!='0') 
errorMessage='Unbalanced parenthesis.';
else 
tokenizedEquation=parenthesis[0];
return tokenizedEquation;
}
function mDAS(stringToCalculate) 
{
var currentNumber, nextNumber, currentOperator, nextOperator, mDBlockComputation;
var runningComputation=0, nextBracketPosition=0, numberOfPasses=0, numberOfMDPasses=0, breakAfterCalculation=0;;
while (stringToCalculate!='' && breakAfterCalculation=='0')
{
if (numberOfPasses=='0') 
{
stringToCalculate=stringToCalculate.substring(1);
currentNumber=equationNumbers[parseInt(stringToCalculate)].getNumber();
currentOperator='';
nextBracketPosition=stringToCalculate.indexOf('[');
if (nextBracketPosition==-1) 
{	
return currentNumber;
}
else
{
nextOperator=stringToCalculate.charAt(nextBracketPosition-1);
stringToCalculate=stringToCalculate.substring(nextBracketPosition+1);
}
nextNumber=equationNumbers[parseInt(stringToCalculate)].getNumber();
}
else
{
currentNumber=nextNumber;
currentOperator=nextOperator;
nextBracketPosition=stringToCalculate.indexOf('[');
if (nextBracketPosition==-1) breakAfterCalculation=1; 
else
{
nextOperator=stringToCalculate.charAt(nextBracketPosition-1);
stringToCalculate=stringToCalculate.substring(nextBracketPosition+1);
}
nextNumber=equationNumbers[parseInt(stringToCalculate)].getNumber();
}
numberOfPasses++;
if ((nextOperator=='+' || nextOperator=='-' || nextOperator=='') && (currentOperator=='+' || currentOperator=='-' || currentOperator==''))
{
if (currentOperator=='+' || currentOperator=='') 
{
runningComputation+=currentNumber; 
}
else if (currentOperator=='-')
{
runningComputation-=currentNumber; 
}
}
if (nextOperator=='*' || nextOperator=='/') 
{
mDBlockComputation=currentNumber;
while ((nextOperator=='*' || nextOperator=='/') && nextOperator!='') 
{
if (numberOfMDPasses=='0')
{
}
else
{
nextBracketPosition=stringToCalculate.indexOf('[');
if (nextBracketPosition==-1)
{
breakAfterCalculation=1; 
nextOperator='';
}
else
{
nextOperator=stringToCalculate.charAt(nextBracketPosition-1);
stringToCalculate=stringToCalculate.substring(nextBracketPosition+1);
}
nextNumber=equationNumbers[parseInt(stringToCalculate)].getNumber();
}
numberOfMDPasses++;
if (nextOperator=='*')
{
mDBlockComputation*=nextNumber;
}
else if (nextOperator=='/')
{
mDBlockComputation=mDBlockComputation/nextNumber;
}
}
if (currentOperator=='+' || currentOperator=='')
{
runningComputation+=mDBlockComputation;
}
else if (currentOperator=='-')
{
runningComputation-=mDBlockComputation;
}
numberOfMDPasses=0;
}
}
return runningComputation;
}
function getStringUpToOperator(stringToParse)
{
var i=0, stringToParseLength=stringToParse.length+1, stringToReturn='', keycode;
if (stringToParse=='')
return false;
while (i<stringToParseLength) {
keycode=stringToParse.charCodeAt(i);
if (keycode==40 || keycode==41 || keycode==42 || keycode==43 || keycode==45 || keycode==47 || keycode==94 || isNaN(keycode)) {
return stringToReturn;
} else {
stringToReturn=stringToReturn+''+stringToParse.charAt(i);
}
i++;
}
return false;
}
function parseFunction(stringToParse)  
{
var i, functionArrayLength=functionArray.length;
if (!stringToParse)
return false;
for (i=1; i<functionArrayLength; i++) {
if (stringToParse==functionArray[i]) {
return i;
}
}
return false;	
}
function formatTrigFunction(trigcalctemp)
{
var trigcalcfinal=trigcalctemp;
var zerotolerance=1e-13;
if (trigcalctemp<=zerotolerance && trigcalctemp>=-zerotolerance) { 
trigcalcfinal=0;
} else if (trigcalctemp<=1+zerotolerance && trigcalctemp>=1-zerotolerance) {
trigcalcfinal=1;
}
return trigcalcfinal;
}
function getVariableIndex(variableName)
{
var i=0, variableLength=variableNames.length;
while (i<variableLength) {
if (variableNames[i++]==variableName)
return (i-1);
}
return -1;
}
function isValidVariable(variableName)
{
var i=0, variableLength=variableName.length, currentKeycode=variableName.charCodeAt(0), alphaCount=0;
if (variableLength===0) {
errorMessage='Undefined variable.'
return false;
}
if (currentKeycode>47 && currentKeycode<58) {
errorMessage=variableName+' must start with a letter.'
return false;
}
if (parseFunction(variableName)) {
errorMessage=variableName+' is already a function.'
return false;
}	
if (variableName=='pi' || variableName=='ans' || variableName=='e') {
errorMessage=variableName+' is locked.';
return false;
}
while (i<variableLength) {
currentKeycode=variableName.charCodeAt(i);
if (currentKeycode>47 && currentKeycode<58); 
else if ((currentKeycode>64 && currentKeycode<91) || (currentKeycode>96 && currentKeycode<123) || (currentKeycode>191 && currentKeycode<256 && currentKeycode!=215 && currentKeycode!=237)) 
alphaCount++;
else {
errorMessage=variableName+' must be alphanumeric.'
return false;	
}	
i++;	
}
if (alphaCount===0) {
errorMessage='Variables cannot be numbers.'
return false;
}
return true;
}
